function [mixmod_est ll_est DD2 theta]=model_estimation(data,mix)
nin=size(data,1);
ncomps_est=mix.ncentres;
theta0 = init(data, ncomps_est);
flag = false;
if flag
    D = mvn2factory(size(data,1));
    D2 = mixturefactory(D, ncomps_est);
    for k=1:ncomps_est
        theta0.D{k} = D.main2new(theta0.D{k});
    end
else
     D = mvnfactory(size(data,1));
    D2 = mixturefactory(D, ncomps_est);
end

options = mxe_options;
%options.theta0 = theta0;
options.penalize = true;

options.solver = 'default';
%options.regularize = true;
options.tolcostdiff = 1e-4;
options.maxiter = 100;% set this to 10 for dataset corresponding to flag=4
options.verbosity = 0;
options.sm.componentd = D;
options.sm.splitcriterion ='mll';
options.sm.mergecriterion = 'overlap';
%options.verbosity = 2;

if mix.ncentres > 2
    [theta, D2] = smem(data, mix.ncentres, options);
else
    theta = D2.estimate(data, options);
end

if flag
    DD = mvnfactory(size(data,1));
    DD2 = mixturefactory(DD, ncomps_est);
    for k=1:ncomps_est
        theta.D{k} = D.new2main(theta.D{k});
    end  
else
    DD2 = D2;
end


if true
    for k=1:ncomps_est
        M0(:,1,k)=theta.D{k}.mu';
        S0(:,:,k)=theta.D{k}.sigma;
        P0(:,:,k)=theta.p(k);
    end
    
    opt.Kini                            = ncomps_est;
    opt.Kmax                            = ncomps_est;
    opt.Kmin                            = ncomps_est;
    % opt.maxite_fullem                   = 500;
    % opt.maxite_partialem                = 500;
    % opt.epsi_fullem                     = 1e-7;
    % opt.epsi_partialem                  = 1e-7;
    % opt.maxcands_split                  = 12;
    % opt.maxcands_merge                  = 12;
    opt.covtype                         = 0;
    
    if false
        [Mest , Sest , Pest , logl] = fsmem_mvgm(data , opt,M0,S0,P0);
    else
        Mest = M0;
        Pest = P0;
        Sest = S0;
    end
    
    %theta = theta0;
    for k=1:ncomps_est
        theta.D{k}.mu = squeeze(Mest(:,1,k));
        theta.D{k}.sigma = squeeze(Sest(:,:,k));
        theta.p(k) = squeeze(Pest(:,:,k));
    end
    
    mixmod_est = gmm(nin, ncomps_est, 'full');
    mixmod_est.priors=reshape(Pest,1,size(Mest,3));
    mixmod_est.covars=Sest;
    for k=1:size(Mest,3)
        mixmod_est.centres(k,:)= Mest(:,:,k)';
    end
else
    mixmod_est = mix;
end

%ll_est1 = calc_loglik(mixmod_est,data)
%ll_est2 = DD2.ll(theta, data)

%ll_est1 - ll_est2

if false
    ll_est = calc_loglik(mixmod_est,data);
else
    ll_est = DD2.ll(theta, data);
end

