
%This file replicate the results of the Third experiment of the paper.
%Here, the performance of different model selection criteria is examined
%versus separation value(delta)
clear all
close all
clc
warning('off','all');
%% data generation
close all
table_index=0;
for delta=0.5:0.2:2.7%changing seprataion with step size 0.2
    fprintf('separation: %2.2f\n',delta)
    table_index=table_index+1;
    dim = 2;
    pp=[0.33 0.33];
    mu1=zeros(1,dim);
    mu2=delta*ones(1,dim);
    mu3=2*delta*ones(1,dim);
    mu = [mu1' mu2' mu3'];
    covar(:,:,1) = eye(dim);
    covar(:,:,2) = eye(dim);
    covar(:,:,3) = eye(dim);
    % y = genmix(500,mu,covar,pp);
    npoints=800;
    self_generation=1;
    
    %% Table calculation
    nCriteria=6;
    nRuns=50;
    kmin=1;
    kmax=6;
    clear r
    for i=1:nRuns
        fprintf('run number:');
        tic
        if self_generation
            data = genmix(npoints,mu,covar,pp);
        end
        if i==nRuns
            fprintf(' %d\n',i);
        else
            fprintf(' %d\n',i);
        end
        r{i}=table_generator(data,kmin,kmax);%the number of components selected by all criteria for i-th run is put in r{i}
        toc
        %pause
    end
    temp_table=zeros(nRuns,nCriteria);
    for i=1:numel(r)
        temp_table(i,:)=r{i}; % r cell array is converted to a table
    end
    Table=zeros(kmax-kmin+1,6);
    for k=kmin:kmax
        for c=1:nCriteria
            Table(k-kmin+1,c)=sum(temp_table(:,c)==k); % table of selections is converted to a table whose arrays determine how many times each number of component is selected by each criterion
        end
    end
    total_Table{table_index}=Table;%total_Table{i} represents the performance Table (like Table 1 in the paper) for i-th separation value(delta)
end
fprintf('The results is stored in total_Table cell array.\ntotal_Table{i} corresponds to the table for i-th delta value\n')
